with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Constants_CFD; use Constants_CFD;

package Parse_File is

   procedure Set_Type_File (Type_File : T_Type_File);
   procedure Set_File_Name (File_Name : Unbounded_String);

   procedure Init;
   procedure Close;

   procedure Get_Next_Element (Key : out Unbounded_String;
                               Value : out Unbounded_String);
private
   TF : T_Type_File := NA;
   FN : Unbounded_String := Null_Unbounded_String;
end Parse_File;
