with Constants_CFD; use Constants_CFD;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Base_Maps;

package Configuration_Maps is
   type T_Configuration_File_Descriptor is tagged record
      DB : Base_Maps.Map;
      FileName : Unbounded_String;
   end record;
   type T_Configuration_File_Descriptor_Access is access all
     T_Configuration_File_Descriptor;

   procedure Load (Obj : access T_Configuration_File_Descriptor;
                   File : Unbounded_String;
                   Type_File : T_Type_File);
   procedure Load (Obj : access T_Configuration_File_Descriptor;
                   File : String;
                   Type_File : T_Type_File);
   function Get (Obj : access T_Configuration_File_Descriptor;
                  Search_Key : Unbounded_String) return Unbounded_String;
   function Get (Obj : access T_Configuration_File_Descriptor;
                  Search_Key : Unbounded_String) return String;
   function Get (Obj : access T_Configuration_File_Descriptor;
                  Search_Key : String) return Unbounded_String;
   function Get (Obj : access T_Configuration_File_Descriptor;
                  Search_Key : String) return String;
end Configuration_Maps;
