with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Configuration_Maps; use Configuration_Maps;
with Constants_CFD; use Constants_CFD;
with Ada.Text_IO;

procedure Test_CFD is
   Obj : aliased T_Configuration_File_Descriptor;
   T1, T2 : Unbounded_String;
begin
   Ada.Text_IO.Put_Line ("Loading File ...");
   Load (Obj'Access, "Test.txt", JAVA_PROPERTIES);


   Ada.Text_IO.Put_Line ("Searching key ...");
   T2 := To_Unbounded_String ("test");
   T1 := Get (Obj'Access, T2);
   Ada.Text_IO.Put_Line (To_String (T1));
   T2 := To_Unbounded_String ("tst");
   begin
      T1 := Get (Obj'Access, T2);
   exception
      when Key_Not_Found =>
         Ada.Text_IO.Put_Line ("Key Not Found");
   end;
   Ada.Text_IO.Put_Line ("End of test ...");
end Test_CFD;
