package Elog.Client is
   type T_Message_Type is (INFORMATION);
   type T_Elog_Client is new T_Elog_Server_Information with private;

   Elog_Client_Initialization_Error : exception;

   procedure Init (Client : in out T_Elog_Client;
                   Hostname : String;
                   Port_Number : Positive;
                   Logbook : String;
                   User_Passwd : String;
                   Author : String);
   procedure Sending_Log (Client : T_Elog_Client;
                          Message_Type : T_Message_Type;
                          Subject : String;
                          Message : String);

   private
      type T_Elog_Client is new T_Elog_Server_Information with
         record
            Logbook : Ada.Strings.Unbounded.Unbounded_String;
            User_Passwd : Ada.Strings.Unbounded.Unbounded_String;
            Author : Ada.Strings.Unbounded.Unbounded_String;
         end record;
end Elog.Client;
