with Ada.Strings.Unbounded;

package Elog is
   type T_Elog_Server_Information is tagged private;
   Elog_Server_Information_Initialization_Error : exception;
   procedure Init (ESI : in out T_Elog_Server_Information;
                   Hostname : String;
                   Port_Number : Positive);
   function Get_Hostname (ESI : T_Elog_Server_Information) return String;
   function Get_Port_Number (ESI : T_Elog_Server_Information) return Positive;
private
   type T_Elog_Server_Information is tagged record
      Hostname : Ada.Strings.Unbounded.Unbounded_String;
      Port_Number : Positive;
   end record;
end Elog;
