with Print_Utils_Base;
with AUnit.Assertions; --  use AUnit.Assertions;

package body Print_Utils_Base.Unit_Test is

   function Equivalent_Values (Val1, Val2 : String) return Boolean is
   begin
      return Val1 = Val2;
   end Equivalent_Values;

   procedure Test_Equivalent_String_Hexa_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := To_String (Hexadecimal (0));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 0 = caracter 0");
   end Test_Equivalent_String_Hexa_0;

   procedure Test_Equivalent_String_Hexa_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1";
      Key2 : constant String := To_String (Hexadecimal (1));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 1 = caracter 1");
   end Test_Equivalent_String_Hexa_1;

   procedure Test_Equivalent_String_Hexa_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "2";
      Key2 : constant String := To_String (Hexadecimal (2));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 2 = caracter 2");
   end Test_Equivalent_String_Hexa_2;

   procedure Test_Equivalent_String_Hexa_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "3";
      Key2 : constant String := To_String (Hexadecimal (3));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 3 = caracter 3");
   end Test_Equivalent_String_Hexa_3;

   procedure Test_Equivalent_String_Hexa_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "4";
      Key2 : constant String := To_String (Hexadecimal (4));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 4 = caracter 4");
   end Test_Equivalent_String_Hexa_4;

   procedure Test_Equivalent_String_Hexa_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "5";
      Key2 : constant String := To_String (Hexadecimal (5));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 5 = caracter 5");
   end Test_Equivalent_String_Hexa_5;

   procedure Test_Equivalent_String_Hexa_6 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "6";
      Key2 : constant String := To_String (Hexadecimal (6));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 6 = caracter 6");
   end Test_Equivalent_String_Hexa_6;

   procedure Test_Equivalent_String_Hexa_7 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7";
      Key2 : constant String := To_String (Hexadecimal (7));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 7 = caracter 7");
   end Test_Equivalent_String_Hexa_7;

   procedure Test_Equivalent_String_Hexa_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "8";
      Key2 : constant String := To_String (Hexadecimal (8));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 8 = caracter 8");
   end Test_Equivalent_String_Hexa_8;

   procedure Test_Equivalent_String_Hexa_9 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "9";
      Key2 : constant String := To_String (Hexadecimal (9));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 9 = caracter 9");
   end Test_Equivalent_String_Hexa_9;

   procedure Test_Equivalent_String_Hexa_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "A";
      Key2 : constant String := To_String (Hexadecimal (10));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 10 = caracter A");
   end Test_Equivalent_String_Hexa_10;

   procedure Test_Equivalent_String_Hexa_11 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "B";
      Key2 : constant String := To_String (Hexadecimal (11));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 11 = caracter B");
   end Test_Equivalent_String_Hexa_11;

   procedure Test_Equivalent_String_Hexa_12 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "C";
      Key2 : constant String := To_String (Hexadecimal (12));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 12 = caracter C");
   end Test_Equivalent_String_Hexa_12;

   procedure Test_Equivalent_String_Hexa_13 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "D";
      Key2 : constant String := To_String (Hexadecimal (13));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 13 = caracter D");
   end Test_Equivalent_String_Hexa_13;

   procedure Test_Equivalent_String_Hexa_14 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "E";
      Key2 : constant String := To_String (Hexadecimal (14));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 14 = caracter E");
   end Test_Equivalent_String_Hexa_14;

   procedure Test_Equivalent_String_Hexa_F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "F";
      Key2 : constant String := To_String (Hexadecimal (15));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : hexadecimal 15 = caracter F");
   end Test_Equivalent_String_Hexa_F;


   procedure Tear_Down (T : in out T_Print_Test_Case) is
   begin
      --  T.Left_Values := T_Mes_Index'Succ (T.Left_Values);
      case T.Left_Values is
	 when 0 =>
	    T.Left_Values := 1;
	 when 1 =>
	    T.Left_Values := 2;
	 when 2 =>
	    T.Left_Values := 3;
	 when 3 =>
	    T.Left_Values := 4;
	 when 4  =>
	    T.Left_Values := 5;
	 when 5 =>
	    T.Left_Values := 6;
	 when 6 =>
	    T.Left_Values := 7;
	 when 7 =>
	    T.Left_Values := 1;
      end case;

   end Tear_Down;


   procedure Test_Equivalent_String_Octal_loop (T : in out AUnit.Test_Cases.Test_Case'Class) is
      --  pragma Unreferenced (T);
      My_T : constant access T_Print_Test_Case := T_Print_Test_Case (T)'Access;
      --  Left_ : constant T_GEC_State := My_T.Left_State;
      Key1 : constant String := To_String (Mon_Tab (My_T.Left_Values));
      Key2 : constant String := To_String (Octal (My_T.Left_Values));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : octal "& Key1 &" /= caracter " & Key2);
   end Test_Equivalent_String_Octal_loop;

   --  procedure Test_Equivalent_String_Octal_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "0";
   --     Key2 : constant String := To_String (Octal (0));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 0 = caracter 0");
   --  end Test_Equivalent_String_Octal_0;

   --  procedure Test_Equivalent_String_Octal_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "1";
   --     Key2 : constant String := To_String (Octal (1));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 1 = caracter 1");
   --  end Test_Equivalent_String_Octal_1;

   --  procedure Test_Equivalent_String_Octal_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "2";
   --     Key2 : constant String := To_String (Octal (2));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 2 = caracter 2");
   --  end Test_Equivalent_String_Octal_2;

   --  procedure Test_Equivalent_String_Octal_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "3";
   --     Key2 : constant String := To_String (Octal (3));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 3 = caracter 3");
   --  end Test_Equivalent_String_Octal_3;

   --  procedure Test_Equivalent_String_Octal_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "4";
   --     Key2 : constant String := To_String (Octal (4));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 4 = caracter 4");
   --  end Test_Equivalent_String_Octal_4;

   --  procedure Test_Equivalent_String_Octal_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "5";
   --     Key2 : constant String := To_String (Octal (5));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 5 = caracter 5");
   --  end Test_Equivalent_String_Octal_5;

   --  procedure Test_Equivalent_String_Octal_6 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "6";
   --     Key2 : constant String := To_String (Octal (6));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 6 = caracter 6");
   --  end Test_Equivalent_String_Octal_6;

   --  procedure Test_Equivalent_String_Octal_7 (T : in out AUnit.Test_Cases.Test_Case'Class) is
   --     pragma Unreferenced (T);
   --     Key1 : constant String := "7";
   --     Key2 : constant String := To_String (Octal (7));
   --  begin
   --     AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : octal 7 = caracter 7");
   --  end Test_Equivalent_String_Octal_7;


   procedure Test_Equivalent_String_Binaire_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := To_String (Binaire (0));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : binaire 0 = caracter 0");
   end Test_Equivalent_String_Binaire_0;

   procedure Test_Equivalent_String_Binaire_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1";
      Key2 : constant String := To_String (Binaire (1));
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : binaire 1 = caracter 1");
   end Test_Equivalent_String_Binaire_1;


   procedure Test_Equivalent_Numeric_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := Numeric_To_String (0);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : natural 0 = caracter 0");
   end Test_Equivalent_Numeric_0;

   procedure Test_Equivalent_Numeric_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1";
      Key2 : constant String := Numeric_To_String (1);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : natural 1 = caracter 1");
   end Test_Equivalent_Numeric_1;

   procedure Test_Equivalent_Numeric_7 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7";
      Key2 : constant String := Numeric_To_String (7);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : natural 7 = caracter 7");
   end Test_Equivalent_Numeric_7;

   procedure Test_Equivalent_Numeric_A (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "A";
      Key2 : constant String := Numeric_To_String (10);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : natural 10 = caracter A");
   end Test_Equivalent_Numeric_A;

   procedure Test_Equivalent_Numeric_F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "F";
      Key2 : constant String := Numeric_To_String (15);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : natural 15 = caracter F");
   end Test_Equivalent_Numeric_F;

   procedure Test_Equivalent_Numeric_Z (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "Z";
      Key2 : constant String := Numeric_To_String (35);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : natural 35 = caracter Z");
   end Test_Equivalent_Numeric_Z;

   procedure Register_Tests (T : in out T_Print_Test_Case) is

      use AUnit.Test_Cases.Registration;
   begin



      T.Left_Values :=  T_Mes_Index'First;
      for Left_Values in T_Mes_Index'Range loop
         Register_Routine (T, Test_Equivalent_String_Octal_loop'Access, "Values of"& Left_Values'Img &" in octal base");
      end loop;


      Register_Routine (T, Test_Equivalent_String_Hexa_0'Access, "To_string => Value hexadecimal of 0 egal caracter 0");
      Register_Routine (T, Test_Equivalent_String_Hexa_1'Access, "To_string => Value hexadecimal of 1 egal caracter 1");
      Register_Routine (T, Test_Equivalent_String_Hexa_2'Access, "To_string => Value hexadecimal of 2 egal caracter 2");
      Register_Routine (T, Test_Equivalent_String_Hexa_3'Access, "To_string => Value hexadecimal of 3 egal caracter 3");
      Register_Routine (T, Test_Equivalent_String_Hexa_4'Access, "To_string => Value hexadecimal of 4 egal caracter 4");
      Register_Routine (T, Test_Equivalent_String_Hexa_5'Access, "To_string => Value hexadecimal of 5 egal caracter 5");
      Register_Routine (T, Test_Equivalent_String_Hexa_6'Access, "To_string => Value hexadecimal of 6 egal caracter 6");
      Register_Routine (T, Test_Equivalent_String_Hexa_7'Access, "To_string => Value hexadecimal of 7 egal caracter 7");
      Register_Routine (T, Test_Equivalent_String_Hexa_8'Access, "To_string => Value hexadecimal of 8 egal caracter 8");
      Register_Routine (T, Test_Equivalent_String_Hexa_9'Access, "To_string => Value hexadecimal of 9 egal caracter 9");
      Register_Routine (T, Test_Equivalent_String_Hexa_10'Access, "To_string => Value hexadecimal of 10 egal caracter A");
      Register_Routine (T, Test_Equivalent_String_Hexa_11'Access, "To_string => Value hexadecimal of 11 egal caracter B");
      Register_Routine (T, Test_Equivalent_String_Hexa_12'Access, "To_string => Value hexadecimal of 12 egal caracter C");
      Register_Routine (T, Test_Equivalent_String_Hexa_13'Access, "To_string => Value hexadecimal of 13 egal caracter D");
      Register_Routine (T, Test_Equivalent_String_Hexa_14'Access, "To_string => Value hexadecimal of 14 egal caracter E");
      Register_Routine (T, Test_Equivalent_String_Hexa_F'Access, "To_string => Value hexadecimal of 15 egal caracter F");

      --  Register_Routine (T, Test_Equivalent_String_Octal_0'Access, "to_string => Value octal of 0 = caracter 0");
      --  Register_Routine (T, Test_Equivalent_String_Octal_1'Access, "to_string => Value octal of 1 = caracter 1");
      --  Register_Routine (T, Test_Equivalent_String_Octal_2'Access, "to_string => Value octal of 2 = caracter 2");
      --  Register_Routine (T, Test_Equivalent_String_Octal_3'Access, "to_string => Value octal of 3 = caracter 3");
      --  Register_Routine (T, Test_Equivalent_String_Octal_4'Access, "to_string => Value octal of 4 = caracter 4");
      --  Register_Routine (T, Test_Equivalent_String_Octal_5'Access, "to_string => Value octal of 5 = caracter 5");
      --  Register_Routine (T, Test_Equivalent_String_Octal_6'Access, "to_string => Value octal of 6 = caracter 6");
      --  Register_Routine (T, Test_Equivalent_String_Octal_7'Access, "to_string => Value octal of 7 = caracter 7");

      Register_Routine (T, Test_Equivalent_String_Binaire_1'Access, "to_string => Value binaire of 0 = caracter 0");
      Register_Routine (T, Test_Equivalent_String_Binaire_0'Access, "to_string => Value binaire of 1 = caracter 1");

      Register_Routine (T, Test_Equivalent_Numeric_0'Access, "to_string => Value natural of 0 = caracter 0");
      Register_Routine (T, Test_Equivalent_Numeric_1'Access, "to_string => Value natural of 1 = caracter 1");
      Register_Routine (T, Test_Equivalent_Numeric_7'Access, "to_string => Value natural of 7 = caracter 7");
      Register_Routine (T, Test_Equivalent_Numeric_A'Access, "to_string => Value natural of 10 = caracter A");
      Register_Routine (T, Test_Equivalent_Numeric_F'Access, "to_string => Value natural of 15 = caracter F");
      Register_Routine (T, Test_Equivalent_Numeric_Z'Access, "to_string => Value natural of 35 = caracter Z");

   end Register_Tests;




   function Name (T : T_Print_Test_Case) return Message_String is
      pragma Unreferenced (T);
   begin
      return new String'("print module util_base");
   end Name;

end Print_Utils_Base.Unit_Test;
