--  <description>
--  This package is a child package of the Read.Numeric.
--  He test all the function in the package Read.Numeric.
--  </description>
--  <group>print_unit_test</group>
--  <c_version>1.0.0</c_version>
with AUnit; use AUnit;
with AUnit.Test_Cases; use AUnit.Test_Cases;

package Read.Numeric.Unit_Test is

   type T_Print_Test_Case is new AUnit.Test_Cases.Test_Case with null record;

   procedure Register_Tests (T : in out T_Print_Test_Case);
   --  <summary>This a procedure to register test procedure in AUnit</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Name (T : T_Print_Test_Case) return Message_String;
   --  <summary>this function give a name to module test in this package and return Message_String</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Equivalent_Values (Val1, Val2 : Integer) return Boolean;
   --  <summary>this function test that values are equal and return a Boolean</summary>
   --  <parameter name="Val1">an Integer</parameter>
   --  <parameter name="Val2">an Integer</parameter>
   --  <exception>no exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_Interne_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>
   procedure Read_Hex_Interne_0xA (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_Interne_0X0001 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_Interne_0x000F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_Interne_0xAD71 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_Interne_0x7FFFFFFF (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>



   procedure Read_Hex_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_0X0001 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_0xA (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_0x000F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_0xAD71 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_0x7FFFFFFF (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Dec_Interne_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_Interne_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_Interne_255 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_Interne_256 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_Interne_2147483647 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_Interne_H8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_Interne_HC (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Dec_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_255 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_256 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_2147483647 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_H8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Dec_HC (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Read_Hex_Dec_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_255 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_256 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_2147483647 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0x00 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0X0001 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0xA (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0x000F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0xAD71 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Read_Hex_Dec_0x7FFFFFFF (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between an Integer of reference
   --           and the return of function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>



   procedure Test_Exception_Dec_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Dec_F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Dec_Interne_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Constraint_Error</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Dec_Interne_F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Constraint_Error</exception>
   --  <seealso>nothing</seealso>


   procedure Test_Exception_Hex_Interne_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Hec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Constraint_Error</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Hex_Interne_G (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Hec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Constraint_Error</exception>
   --  <seealso>nothing</seealso>
   procedure Test_Exception_Hex_Interne_Diese (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Hec_Interne.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Constraint_Error</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Hex_G (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Hex_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Hex_Diese (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Hex_Dec_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Exception_Hex_Dec_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test the exception function Read_Hex_Dec.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>Test success when the execption is Wrong_Type</exception>
   --  <seealso>nothing</seealso>

end Read.Numeric.Unit_Test;


