package body Text_File is

   ---------------
   -- Open_File --
   ---------------

   procedure Open_File (File_Name : Unbounded_String) is
   begin
      Ada.Text_IO.Open (File_Txt_IO,
                        Ada.Text_IO.In_File,
                        To_String (File_Name),
                        "shared=yes");
   end Open_File;

   -----------
   -- Close --
   -----------

   procedure Close_File is
   begin
      Ada.Text_IO.Close (File_Txt_IO);
   end Close_File;

end Text_File;
