--  <description>
--  Package of definition which allows to transform bases decimal in binary base
--  </description>
--  <group>Print</group>
--  <version>1.0.0</version>

package Print.Numeric.Binary is

   function Binary_To_String (N : Natural; Width : Natural := 0) return String;
   --  <summary>Convert a number at binary base with a width wanted and return a string</summary>
   --  <parameter name="N">A natural</parameter>
   --  <parameter name="Width">A natural</parameter>
   --  <exception>No exception</exception>
   --  <seealso>print.numeric</seealso>
   function Format (S : String) return String;
   --  <summary>Post the releases of conversion in package of 4 numbers in a string</summary>
   --  <parameter name="S">A string</parameter>
   --  <exception>No exception</exception>
end Print.Numeric.Binary;
