package body Print_Utils_Base is



   function Numeric_To_String (N : Natural) return String is
   begin
      if (N < 10) then
         return Integer'Image (N) (2 .. 2);
      else
         return Alphabet'Image (Alphabet'Val (N - 10));
      end if;
   end Numeric_To_String;

   -------------
   -- To_String --
   -------------

   function To_String (N : Hexadecimal) return String is
   begin
      return Numeric_To_String (Natural (N));
   end To_String;

   -------------
   -- To_String --
   -------------

   function To_String (N : Octal) return String is
   begin
      return Numeric_To_String (Natural (N));
   end To_String;

   -------------
   -- To_String --
   -------------

   function To_String (N : Binaire) return String is
   begin
      return Numeric_To_String (Natural (N));
   end To_String;

end Print_Utils_Base;

