with AUnit; use AUnit;
with AUnit.Test_Cases;
use AUnit.Test_Cases;

--  <description>
--  this package for test differents function of the package
--  print-numeric-binary
--  </description>
--  <group>print_unit_test</group>


package Print.Numeric.Binary.Unit_Test is

   type T_Print_Test_Case is new AUnit.Test_Cases.Test_Case with null record;

   procedure  Register_Tests (T : in out T_Print_Test_Case);
   --  <summary>This a procedure to register test procedure in AUnit</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Name (T : T_Print_Test_Case) return Message_String;
   --  <summary>this function give a name to module test in this package and return Message_String</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Equivalent_Values (Val1, Val2 : String) return Boolean;
   --  <summary>this function test that values are equal and return a Boolean</summary>
   --  <parameter name="Val1">a String</parameter>
   --  <parameter name="Val2">a String</parameter>
   --  <exception>no exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test format function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format</seealso>
   procedure Test_Format_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test format function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format</seealso>
   procedure Test_Format_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test format function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format</seealso>

   procedure Test_Binary_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>
   procedure Test_Binary_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>
   procedure Test_Binary_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>
   procedure Test_Binary_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>
   procedure Test_Binary_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>
   procedure Test_Binary_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>
   procedure Test_Binary_To_String_first (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Binary_To_String function</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Print.Numeric.Binary.Format.Binary_To_String</seealso>

end Print.Numeric.Binary.Unit_Test;
