--  <description>
--  This package is a child package of the print.numeric.Hexadecimal.
--  He test all the function in the package print.numeric.Hexadecimal.
--  </description>
--  <group>print_unit_test</group>
--  <c_version>1.0.0</c_version>
with AUnit; use AUnit;
with AUnit.Test_Cases;
use AUnit.Test_Cases;

package Print.Numeric.Hexadecimal.Unit_Test is

   type T_Print_Test_Case is new AUnit.Test_Cases.Test_Case with null record;

   procedure  Register_Tests (T : in out T_Print_Test_Case);
   --  <summary>This a procedure to register test procedure in AUnit</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Name (T : T_Print_Test_Case) return Message_String;
   --  <summary>this function give a name to module test in this package and return Message_String</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>no exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Equivalent_Values (Val1, Val2 : String) return Boolean;
   --  <summary>this function test that values are equal and return a Boolean</summary>
   --  <parameter name="Val1">a String</parameter>
   --  <parameter name="Val2">a String</parameter>
   --  <exception>no exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_1_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_2_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_87_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_28000_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_last_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_last_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_last_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_String_16_f (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Hexa_To_String.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Test_Equivalent_Hexa_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_1_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_2_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_87_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_28000_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_last_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_last_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Hexa_last_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function To_Hexa.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>



   procedure Test_Equivalent_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_001 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_0057 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_6D60 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_last8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_last10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Format_S (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference and the return of function Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>



   procedure Test_Equivalent_Ada_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_001 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_0057 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_6D60 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_last8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_last10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_Ada_Format_S (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>


   procedure Test_Equivalent_C_To_Ada_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_C_To_Ada_Format_001 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_C_To_Ada_Format_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_C_To_Ada_Format_0057 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_C_To_Ada_Format_6D60 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_C_To_Ada_Format_last8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>

   procedure Test_Equivalent_C_To_Ada_Format_last10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This procedure test equivalent between a string of reference
   --           and the return of function C_To_Ada_Format.</summary>
   --  <parameter name="T">that a global object of all tests</parameter>
   --  <exception>No exception</exception>
   --  <seealso>nothing</seealso>




end  Print.Numeric.Hexadecimal.Unit_Test;
