with AUnit; use AUnit;
with AUnit.Test_Cases; use AUnit.Test_Cases;

--  <description>
--  This package for test differents function of the package
--  print-numeric-binary
--  </description>
--  <group>Print_unit_test</group>

package Print.Numeric.Unit_Test is

   type T_Print_Test_Case is new AUnit.Test_Cases.Test_Case with null record;

   procedure Register_Tests (T : in out T_Print_Test_Case);
   --  <summary>This a procedure to register test procedure in AUnit</summary>
   --  <parameter name="T">That a global object of all tests</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Name (T : T_Print_Test_Case) return Message_String;
   --  <summary>This function give a name to module test in this package and return Message_String</summary>
   --  <parameter name="T">That a global object of all tests</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Equivalent_Values (Val1, Val2 : String) return Boolean;
   --  <summary>This function test that values are equal and return a Boolean</summary>
   --  <parameter name="Val1">A String</parameter>
   --  <parameter name="Val2">A String</parameter>
   --  <exception>No exception</exception>
   --  <seealso>Nothing</seealso>

   procedure Test_Last;

   procedure Number_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Number_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Number_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_6 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_7 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_9 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_11 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_12 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_13 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_14 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_15 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_16 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_17 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Number_To_String_18 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Number_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Base_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_6 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_7 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Base_To_String_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Base_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Preformat_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Preformat_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Preformat_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Preformat_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Preformat_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Preformat_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Preformat_6 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Preformat function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Not_Numeric_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test others attributes of Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Numeric_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Not_Numeric_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test others attributes of Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Numeric_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Not_Numeric_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test others attributes of Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Numeric_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Numeric_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Numeric_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Numeric_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
end Print.Numeric.Unit_Test;
